//
// Copyright 2008, Lowell Boggs Jr.
//
// This file or directory, containing source code for a computer program,
// is Copyrighted by Lowell Boggs, Jr.  987 Regency Drive, Lewisville
// TX (USA), 75067.  You may use, copy, modify, and distribute this
// source file without charge or obligation so long as you agree to
// the following:
//
//  1.  You must indemnify Lowell Boggs against any and all financial
//      obligations caused by its use, misuse, function, or malfunction.
//      Further, you acknowledge that there is no warranty of any kind,
//      whatsoever.
//
//  2.  You agree not to attempt to patent any portion of this original
//      work -- though you may attempt to patent your own extensions to
//      it if you so choose.
//
//  3.  You keep this copyright notice with the file and all copies
//      of the file and do not change it anyway except language translation.
//
// You are responsible for enforcing your own compliance with these
// conditions and may not use this source file if you cannot agree to the
// above terms and conditions.
//

#include "sformat.h"
#include <iostream>
#include <iomanip>

using namespace std;

template<class T, class U>
Sformatter<void> sf(T const &t, U const &u)
{
  return Sformatter<void>(*&t, *&u);
}



int main()
{
#if 1

  string x = Sformat(40);
  string y = Sformat(hex, 40);


  cout << "Sformat(40) => "      << x << endl;
  cout << "Sformat(hex, 40) => " << y << endl;

  cout << "Sformat(1) SFormat(2) SFormat(3) => "                // bad!  not supposed to work
       << Sformat(1) << Sformat(2) << Sformat(3) 
       << "  !!! not supposed to be correct!" << endl;

  cout << "Sformat(setw(22), setprecision(9), 10.9123456789012345) => " 
       << Sformat(setw(22), setprecision(9), 10.9123456789012345) << endl;


  cout << "Sformat(hex, 16, ' ', hex, 48)    " << Sformat(hex, 16, ' ', hex, 48) << endl;
         

#else
  for(int i = 0; i < 1000 * 1000; ++i)
  {
    #if 1
      std::string const &s = Sformat(i);
      // cout << p << endl;
    #else

      #if 0

      #else

        char buffer[40];
        sprintf(buffer, "%d", i);


      #endif
    #endif

  }
#endif

}
